
/*
 * Copyright (c) 2016 Cybozu
 * Licensed under the MIT License
 */

(() => {
    'use strict';
  
    const autoNum = (event) => {
      const record = event.record;
  
      // 日付を取得し、2桁の年を取得する
      const dt = record['日付'].value;
      const dtyy = dt.substring(0, 4);
      const dtmin = `${dtyy}-01-01`;
      const dtmax = `${(parseInt(dtyy, 10) + 1)}-01-01`;
  
      // クエリ文の設定
      const query = {
        'app': kintone.app.getId(),
        'query': `日付 >= "${dtmin}" and 日付 < "${dtmax}" order by 自動採番 desc limit 1`
      };
  
      // 設定された日付から最新の番号を取得する
      return kintone.api(kintone.api.url('/k/v1/records', true), 'GET', query).then((resp) => {
        const records = resp.records;
  
        // 対象レコードがあった場合
        if (records.length > 0) {
          const rec = records[0];
          let autono = rec['自動採番'].value;
          autono = parseInt(autono.substring(3), 10) + 1;
          autono = `00000${autono}`;
          autono = `${dt.substring(2, 4)}-${autono.substring(autono.length - 5)}`;
          event.record['自動採番'].value = autono;
  
          // 対象レコードがなかった場合
        } else {
          event.record['自動採番'].value = `${dt.substring(2, 4)}-00001`;
        }
        return event;
      }).catch((e) => {
        alert(`レコードの取得でエラーが発生しました  - error: ${e.message}`);
        return false;
      });
    };
  
    // 新規作成画面の保存
    kintone.events.on('app.record.create.submit', autoNum);
  
    // 新規作成画面表示
    kintone.events.on('app.record.create.show', (event) => {
      const record = event.record;
      // フィールドを非活性にする
      record['自動採番'].disabled = true;
      return event;
    });
  
    // 編集画面表示
    kintone.events.on(['app.record.edit.show', 'app.record.index.edit.show'], (event) => {
      const record = event.record;
      // フィールドを非活性にする
      record['自動採番'].disabled = true;
      record['日付'].disabled = true;
      return event;
    });
  
  })();
  