/*
 * 回答の条件によってグループフィールドの開閉を切り替えるサンプルプログラム
 *
 * Licensed under the MIT License
 */

(() => {

    'use strict';
  
    // ラジオボタンの値によって開くグループフィールドを変更する操作
    const eventsSubmit = ['app.record.detail.show',
      'app.record.create.show',
      'app.record.edit.show',
      'app.record.create.change.ラジオボタン',
      'app.record.edit.change.ラジオボタン'];
    kintone.events.on(eventsSubmit, (e) => {
      const record = e.record;
      const radioButtonValue = record.ラジオボタン.value;
  
      // グループフィールド開閉APIを用いて、まず全てのグループフィールドを閉じる
      kintone.app.record.setGroupFieldOpen('group_failure', false);
      kintone.app.record.setGroupFieldOpen('group_demand', false);
      kintone.app.record.setGroupFieldOpen('group_question', false);
      kintone.app.record.setGroupFieldOpen('group_other', false);
  
      // ラジオボタンの値によって開くグループフィールドを切り替える
      switch (radioButtonValue) {
        case '不具合':
          kintone.app.record.setGroupFieldOpen('group_failure', true);
          break;
        case '要望':
          kintone.app.record.setGroupFieldOpen('group_demand', true);
          break;
        case '質問':
          kintone.app.record.setGroupFieldOpen('group_question', true);
          break;
        case 'その他':
          kintone.app.record.setGroupFieldOpen('group_other', true);
          break;
      }
    });
  })();  